# Preference Settings Documentation

This document lists the settings defined in `preference_edition.xml`.

## Display

### Display all menus in edition mode

- **Type:** `CheckBoxPreference`
- **Key:** `pref_edit_mode_menu_all`
- **Default Value Resource:** `false`

### Set preview as note edition default display

- **Type:** `CheckBoxPreference`
- **Key:** `pref_edit_mode_view`
- **Default Value Resource:** `false`

### New interface for preview note

- **Type:** `CheckBoxPreference`
- **Key:** `pref_edit_mode_view_ui`
- **Default Value Resource:** `true`

### New interface for editing note

- **Type:** `CheckBoxPreference`
- **Key:** `pref_edit_mode_edit_ui`
- **Default Value Resource:** `false`

### Edition buttons horizontal

- **Type:** `CheckBoxPreference`
- **Key:** `pref_forceEditionButtonsH`
- **Default Value Resource:** `false`

### Top padding for note\'s content

- **Type:** `EditTextPreference`
- **Key:** `pref_edit_note_padding_top`

### Bottom padding for note\'s content

- **Type:** `EditTextPreference`
- **Key:** `pref_edit_note_padding_bottom`

### Left padding for note\'s content

- **Type:** `EditTextPreference`
- **Key:** `pref_edit_note_padding_left`

### Right padding for note\'s content

- **Type:** `EditTextPreference`
- **Key:** `pref_edit_note_padding_right`

## Edition

### Set cursor on title when new note

- **Type:** `CheckBoxPreference`
- **Key:** `pref_edit_cursor_title_new_note`
- **Default Value Resource:** `false`

### Set cursor at the end when opening note

- **Type:** `CheckBoxPreference`
- **Key:** `pref_edit_cursor_end`
- **Default Value Resource:** `false`

### Enable capitalization on title

- **Type:** `CheckBoxPreference`
- **Key:** `pref_edit_capitalize_title`
- **Default Value Resource:** `false`

### Enable capitalization on note content

- **Type:** `CheckBoxPreference`
- **Key:** `pref_edit_capitalize_note`
- **Default Value Resource:** `false`

### Autosave interval in second

- **Type:** `EditTextPreference`
- **Key:** `pref_autosave_interval`
- **Summary:** 0 to disable

## Search

### Case sensitive research 

- **Type:** `CheckBoxPreference`
- **Key:** `pref_edit_mode_search_sensitive`
- **Default Value Resource:** `false`

### Match exact word 

- **Type:** `CheckBoxPreference`
- **Key:** `pref_edit_mode_search_word`
- **Default Value Resource:** `false`

## Color in edition

### Menus color

- **Type:** `app.varlorg.ambilwarna.widget.AmbilWarnaPreference`
- **Key:** `pref_note_button_edit`
- **Default Value Resource:** `0xff999999`
- **Reset Value Resource:** `0xff999999`

### Color of bottom buttons

- **Type:** `app.varlorg.ambilwarna.widget.AmbilWarnaPreference`
- **Key:** `pref_note_button_bottom_edit`
- **Default Value Resource:** `0xff000001`
- **Reset Value Resource:** `0xff000001`

### Text Color in edition screen

- **Type:** `app.varlorg.ambilwarna.widget.AmbilWarnaPreference`
- **Key:** `pref_note_text_color_edit_all`
- **Default Value Resource:** `0xff999999`
- **Reset Value Resource:** `0xff999999`

### Background color

- **Type:** `app.varlorg.ambilwarna.widget.AmbilWarnaPreference`
- **Key:** `pref_color_edit_bg`
- **Default Value Resource:** `0xff000001`
- **Reset Value Resource:** `0xff000001`

### Action bar color

- **Type:** `app.varlorg.ambilwarna.widget.AmbilWarnaPreference`
- **Key:** `pref_color_edit_bar`
- **Default Value Resource:** `0xff000001`
- **Reset Value Resource:** `0xff000001`

### Use specific colors on edition screen

- **Type:** `CheckBoxPreference`
- **Key:** `pref_note_text_color_edit_bool`
- **Default Value Resource:** `false`

### Title\'s color

- **Type:** `app.varlorg.ambilwarna.widget.AmbilWarnaPreference`
- **Key:** `pref_note_text_color_title_edit`
- **Default Value Resource:** `0xff999999`
- **Reset Value Resource:** `0xff999999`

### Note\'s color

- **Type:** `app.varlorg.ambilwarna.widget.AmbilWarnaPreference`
- **Key:** `pref_note_text_color_note_edit`
- **Default Value Resource:** `0xff999999`

### Note description\'s color

- **Type:** `app.varlorg.ambilwarna.widget.AmbilWarnaPreference`
- **Key:** `pref_note_text_color_note_edit_desc`
- **Default Value Resource:** `0xff999999`
- **Reset Value Resource:** `0xff999999`

### Title description\'s color

- **Type:** `app.varlorg.ambilwarna.widget.AmbilWarnaPreference`
- **Key:** `pref_note_text_color_title_edit_desc`
- **Default Value Resource:** `0xff999999`
- **Reset Value Resource:** `0xff999999`
